﻿using Abstractions.Modules;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.VisualStudio.TestTools.UnitTesting.Web;
using System.Web;
using System.Collections.Specialized;
using Moq;

namespace Abstractions.Tests.Modules
{
    
    
    /// <summary>
    ///This is a test class for FilterForbiddenWordModuleTest and is intended
    ///to contain all FilterForbiddenWordModuleTest Unit Tests
    ///</summary>
    [TestClass()]
    public class FilterForbiddenWordModuleTest
    {
        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Filter
        ///</summary>
        [TestMethod()]
        public void FilterTest()
        {
            var collection = new NameValueCollection();
            collection["__cannot_be_filtered"] = "FORBIDDEN_WORD";
            collection["should_be_filtered"] = "FORBIDDEN_WORD";

            var requestMock = new Mock<HttpRequestBase>();
            requestMock.Expect(r => r.Form).Returns(collection);

            var contextMock = new Mock<HttpContextBase>();
            contextMock.Expect(c => c.Request).Returns(requestMock.Object);

            FilterForbiddenWordModule.Filter(contextMock.Object);

            Assert.AreEqual("FORBIDDEN_WORD", collection["__cannot_be_filtered"],
                "The value whose key starts with '__' cannot be filtered");

            Assert.AreEqual("*", collection["should_be_filtered"],
                "The forbidden word should be filtered.");
        }
    }
}
