﻿using Abstractions.Mvp;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.VisualStudio.TestTools.UnitTesting.Web;
using System;
using Moq;
using System.Collections.Specialized;
using System.Web;

namespace Abstractions.Tests.Mvp
{
    /// <summary>
    ///This is a test class for DisplayUserPresenterTest and is intended
    ///to contain all DisplayUserPresenterTest Unit Tests
    ///</summary>
    [TestClass()]
    public class DisplayUserPresenterTest
    {
        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        ///A test for DisplayUserPresenter
        ///</summary>
        [TestMethod()]
        public void DisplayUserPresenterImplTest()
        {
            var form = new NameValueCollection();
            form["UserName"] = "Jeffrey Zhao";
            form["Password"] = "123456";

            var mockRequest = new Mock<HttpRequestBase>();
            mockRequest.Expect(r => r.Form).Returns(form);

            var mockContext = new Mock<HttpContextBase>();
            mockContext.Expect(c => c.Request).Returns(mockRequest.Object);

            var mockView = new Mock<IDisplayUserView>();
            mockView.Expect(v => v.Context).Returns(mockContext.Object);

            User userToDisplay = null;
            mockView.ExpectSet(v => v.UserToDisplay).Callback(u => {userToDisplay = u;});
            
            var view = mockView.Object;
            var presenter = new DisplayUserPresenter(mockView.Object);

            presenter.OnInit();
            presenter.OnLoad();

            Assert.IsNotNull(userToDisplay, "The presenter should set the user to display");
            Assert.AreEqual("Jeffrey Zhao", userToDisplay.UserName);
            Assert.AreEqual("123456", userToDisplay.Password);
        }
    }
}
