﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Collections.Specialized;
using System.Reflection;

namespace Abstractions.Modules
{
    public class FilterForbiddenWordModule : IHttpModule
    {
        private static PropertyInfo s_isReadOnlyPropertyInfo;

        static FilterForbiddenWordModule()
        {
            Type type = typeof(NameObjectCollectionBase);
            s_isReadOnlyPropertyInfo = type.GetProperty("IsReadOnly", BindingFlags.Instance | BindingFlags.NonPublic);
        }

        #region IHttpModule Members

        public void Init(HttpApplication context)
        {
            context.BeginRequest += (sender, args) =>
            {
                Filter(new HttpContextWrapper((sender as HttpApplication).Context));
            };
        }

        public static void Filter(HttpContextBase context)
        {
            ProcessCollection(context.Request.Form);
        }

        private static void ProcessCollection(NameValueCollection collection)
        {
            if (collection.Count <= 0) return;

            var copy = new NameValueCollection();

            foreach (string key in collection.AllKeys)
            {
                if (key.StartsWith("__"))
                {
                    Array.ForEach(collection.GetValues(key), v => copy.Add(key, v));
                }
                else
                {
                    Array.ForEach(collection.GetValues(key), v => copy.Add(key, Filter(v)));
                }
            }

            s_isReadOnlyPropertyInfo.SetValue(collection, false, null);

            collection.Clear();
            collection.Add(copy);

            s_isReadOnlyPropertyInfo.SetValue(collection, true, null);
        }

        private static string Filter(string original)
        {
            return original.Replace("FORBIDDEN_WORD", "*");
        }

        public void Dispose() { }

        #endregion
    }
}
