﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Abstractions.Mvp
{
    public abstract class PresenterBase<T> where T : IView
    {
        protected T View { get; private set; }

        protected PresenterBase(T view)
        {
            this.View = view;
        }

        public virtual void OnInit() { }

        public virtual void OnLoad() { }
    }
}
