﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace AsyncAction.Async
{
    public class AsyncMvcRouteHandler : MvcRouteHandler
    {
        protected override IHttpHandler GetHttpHandler(RequestContext requestContext)
        {
            var asyncHandler = new AsyncMvcHandler(requestContext);
            return this.IsAsyncRequest(requestContext, asyncHandler) ? asyncHandler : base.GetHttpHandler(requestContext);
        }

        private bool IsAsyncRequest(RequestContext requestContext, AsyncMvcHandler asyncHandler)
        {
            var actionName = requestContext.RouteData.GetRequiredString("action");
            var controllType = asyncHandler.Controller.GetType();

            return AsyncController.GetBeginMethod(controllType, actionName) != null &&
                AsyncController.GetEndMethod(controllType, actionName) != null;
        }
    }
}
